/***
 * Excerpted from "No Fluff Just Stuff 2007",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs07 for more book information.
***/
package com.acme.client;

import com.google.gwt.core.client.*;
import com.google.gwt.user.client.ui.*;

public class LoginApplication 
   implements EntryPoint, HistoryListener {
  private static final String LOGIN_STATE = "login";
  private static final String WELCOME_STATE = "welcome";

  private static final LoginApplicationConstants constants =
        (LoginApplicationConstants)GWT.create
              (LoginApplicationConstants.class);

  public void onModuleLoad() {
    setupHistory();
  }
  private void setupHistory() {
    History.addHistoryListener(this);
    History.onHistoryChanged(LOGIN_STATE);
  }
  public void onHistoryChanged(String historyToken) {
    if (LOGIN_STATE.equals(historyToken)) {
       loadLoginView();
    }
    else if (WELCOME_STATE.equals(historyToken)) {
       loadWelcomeView();
    }
  }
  private void loadLoginView() {
    final Label loginPrompt = new Label(constants.loginPrompt());
    final Grid grid = new Grid(3,2);
    final Label namePrompt = new Label(constants.namePrompt());    
    final TextBox nameTextbox = new TextBox();
    final Label passwordPrompt = new Label(constants.passwordPrompt());    
    final PasswordTextBox passwordTextbox = new PasswordTextBox();
    final Button button = new Button("Login");
        
    RootPanel.get().clear();
    
    button.addClickListener(new ClickListener() {
      public void onClick(Widget sender) {
         LoginServiceAsync ls = (LoginServiceAsync)
            GWT.create(LoginService.class);
         ServiceDefTarget target = (ServiceDefTarget)ls;
         target.setServiceEntryPoint(GWT.getModuleBaseURL() +
                                   "/loginService");
         
         ls.isValidLogin(nameTextbox.getText(),
                       passwordTextbox.getText(),
                       new AsyncCallback() {
         public void onSuccess(Object result) {
            if (true == ((Boolean)result).booleanValue()) {
               History.newItem(WELCOME_STATE);
            }
            else {
               Window.alert("Invalid name/pwd combination. " +
                          "Please try again.");
            }
         }
         public void onFailure(Throwable caught) {
            Window.alert("rpc call failed: " + caught.getMessage());
         }
         });
      }
    });

    loginPrompt.addStyleName("loginPrompt");
    nameTextbox.addStyleName("nameField");
    passwordTextbox.addStyleName("passwordField");

    RootPanel.get().add(loginPrompt);
    
    grid.setWidget(0, 0, namePrompt);
    grid.setWidget(0, 1, nameTextbox);

    grid.setWidget(1, 0, passwordPrompt);
    grid.setWidget(1, 1, passwordTextbox);
    
    grid.setWidget(2, 0, button);
    
    RootPanel.get().add(grid);
  }
  private void loadWelcomeView() {
     final Label welcomeMsg = new Label(constants.welcomeMsg());
        
     welcomeMsg.addStyleName("welcomeMsg");
     
     RootPanel.get().clear();
     RootPanel.get().add(welcomeMsg);
     RootPanel.get().add(
         new Hyperlink(constants.logoutLinkText(), LOGIN_STATE));
  }
}
