/***
 * Excerpted from "No Fluff Just Stuff 2007",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs07 for more book information.
***/
package com.howardlewisship.easymockexamples;

public class OrderProcessorImpl implements OrderProcessor
{
    private final InventoryManager _manager;

    public OrderProcessorImpl(InventoryManager manager)
    {
        _manager = manager;
    }

    public void processLineItem(String productId, int quantity, Order order)
    {
        int available = _manager.quantityAvailable(productId);

        if (available >= quantity)
        {
            order.addLineItem(productId, quantity, false);
            return;
        }

        if (available > 0)
        {
            order.addLineItem(productId, available, false);
            order.addLineItem(productId, quantity - available, true);
            return;
        }

        order.addLineItem(productId, quantity, true);
    }

}
