/***
 * Excerpted from "No Fluff Just Stuff 2007",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs07 for more book information.
***/
package com.howardlewisship.easymockexamples;

import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;

import org.easymock.EasyMock;
import org.testng.Assert;
import org.testng.annotations.Test;

public class OrderProcessorImplTest extends Assert
{
    public static final String PRODUCT_ID = "prod-0001";

    @Test
    public void sufficient_quantity_available()
    {
        InventoryManager manager = EasyMock.createMock(InventoryManager.class);
        Order order = EasyMock.createMock(Order.class);

        expect(manager.quantityAvailable(PRODUCT_ID)).andReturn(100);

        order.addLineItem(PRODUCT_ID, 50, false);

        replay(manager, order);

        OrderProcessor processor = new OrderProcessorImpl(manager);

        processor.processLineItem(PRODUCT_ID, 50, order);

        verify(manager, order);
    }
}
